<template>
  <b-dropdown
    class="ac-material-dropdown"
    v-bind="button_options"
    :right="right"
    no-caret
  >
    <!-- Toggle button content -->
    <template slot="button-content">
      <i :class="button_options.icon"></i>
    </template>

    <!--
      List of dropdown options.
      On options click calls handler from option
     -->
    <b-dropdown-item
      v-for="item in options"
      :key="item.label"
      @click="on_item_click(item)"
    >
      <i
        :class="item.icon"
        class="mr-3"
      />
      {{ item.label }}
    </b-dropdown-item>
  </b-dropdown>
</template>

<script>
/**
 * ac Material Dropdown component
 * @requires VueBootstrap
 */

export default {
  name: 'ac-material-dropdown',

  props: {
    /**
     * @param {array} options - list of dropdown options.
     * Each option must contain label and icon properties
     */
    options: {
      type: Array,
      required: true,
    },

    /**
     * @param {object} button_options - Options for toggle button.
     * Must contain keys 'icon' with icon class and 'variant' with button variant
     * Variant types: https://bootstrap-vue.js.org/docs/components/button/
     */
    button_options: {
      type: Object,
      required: true,
    },

    /**
     * @param {boolean} right - Alignment of dropdown menu.
     * If false - left, if true - right
     */
    right: {
      type: Boolean,
      default: false,
    },
  },

  methods: {
    /**
     * @function on_item_click - dropdown option click handler.
     * @fires item_click
     */
    on_item_click(item) {
      /**
       * Option click event
       * @event item_click
       * @type {string} type of click, from option props.
       */
      this.$emit('item_click', item.type)
    },
  },
}
</script>
